classdef Data < handle
    % This class will store the data for each table, ideally to seperate
    % out the data from the gui and logic.
    
    properties
        Grid0 = [];
        Grid1 = [];
        Grid2 = [];
        function_name = [];
        function_inputs = [];
        settings = [];
        checked = [];
        open = [];
        fig = [];
    end
    
    
    
    methods
        
        function obj = Data()
            
        end
        
        function [] = setData(object, grid0, grid1, grid2, name, inputs, checked)
            object.Grid0 = grid0;
            object.Grid1 = grid1;
            object.Grid2 = grid2;
            object.function_name = name;
            object.function_inputs = inputs;
            object.checked = checked;
        end
        
        function [] = init(object)
            object.Grid2 = Grid(2,[]);
            object.Grid1 = Grid(1,[]);
            object.Grid0 = RGrid(object.Grid1,object.Grid2);
            object.Grid1.set_rGrid(object.Grid0);
            object.Grid2.set_rGrid(object.Grid0);
            object.Grid2.new_Cell;
            object.Grid1.new_Cell;
            object.checked = 0;
            
            
        end
        
        function [grid0, grid1, grid2, name, inputs, checked] = getData(object)
            grid0 = object.Grid0;
            grid1 = object.Grid1;
            grid2 = object.Grid2;
            name = object.function_name;
            inputs = object.function_inputs;
            checked = object.checked;
        end
    
        function valid = valid(object)
            if isempty(object.Grid0)
                valid = 0;
                return
            end
            if isempty(object.Grid1)
                valid = 0;
                return
            end
            if isempty(object.Grid2)
                valid = 0;
                return
            end
            valid = 1;
        
        end
        
         %% clone
        % creates copy of object
        function copy = clone(obj,handle)
            % assume that dialog is closed
            copy = Data();
            copy.function_name =   get(handle,'Name');
            copy.function_inputs = obj.function_inputs;
            copy.checked = obj.checked;
            copy.settings = obj.settings;
            
            
            copy.Grid2 = Grid(2,[]);
            copy.Grid1 = Grid(1,[]);
            copy.Grid0 = RGrid(copy.Grid1,copy.Grid2);
            copy.Grid1.set_rGrid(copy.Grid0);
            copy.Grid2.set_rGrid(copy.Grid0);
            

            obj.Grid2.clone(copy.Grid2,obj.Grid2.grid_index,[])
            obj.Grid1.clone(copy.Grid1,obj.Grid1.grid_index,[])
            
            obj.copy_results(copy)

        end
        
        function [] = setvalues(obj,settings)
            obj.settings = settings;
        end
        
        function [] = copy_results(obj,dest)
            for i=1:size(dest.Grid0.Cells,2)
                for j=1:size(obj.Grid0.Cells,2)
                    if (strcmp(obj.Grid0.Cells(j).Cell1.cond_text,dest.Grid0.Cells(i).Cell1.cond_text) && strcmp(obj.Grid0.Cells(j).Cell2.cond_text,dest.Grid0.Cells(i).Cell2.cond_text))
                        dest.Grid0.Cells(i).result_text = obj.Grid0.Cells(j).result_text;
                    end
                end
            end
        end
        
        function [] = save(obj)
            filename = [ obj.function_name '.table'];
            save(filename,'obj');
        end
    end
    
end

