classdef EMLGenerator < handle
    %UNTITLED Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        data = [];
        datatype = [];
    end
    
    methods(Static)
        %%
        function revised_input = parse_inputs(input_string)
            revised_input = [];
            input_string2 = reshape(input_string',1,size(input_string,1)*size(input_string,2));
           inputs = regexprep(input_string2,'\s','');
           inputs = regexp(inputs,',','split');
           
           % need to be careful here because pvs dependant types can have
           % :'s in them
           
           % find the first :, any thing before this is considered the
           % variable any thing following is considered the type
           c_locations = regexp(inputs,':','start');
           for i= 1:size(inputs,2)
                if size(c_locations{i},2) == 0
                    sub_input{1} = inputs{i};
                    new_inputs{i} = sub_input;
                else
                    sub_input{1} = inputs{i}(1:c_locations{i}(1)-1);
                    sub_input{2} = inputs{i}(c_locations{i}(1)+1:end);
                    new_inputs{i} = sub_input;
                    %new_inputs{i}(1) = inputs{i}(1:c_locations{i}(1))
                    %new_inputs{i}(2) = inputs{i}(c_locations{i}(1):end)
                end
                    
           end
           
           %inputs = regexp(inputs,':','split')
           
           for i=1:size(new_inputs,2)
                valid = regexp(new_inputs{i}(1),'[a-zA-Z][_a-zA-Z0-9]*','match');
                if ~strcmp(new_inputs{i}(1),valid{1})
                    new_inputs{i}(2) = {'error'};
                    %revised_input = cat(2,revised_input,[char(inputs{i}(1)); 'error'])
                end
           end 
           if isempty(revised_input)
               revised_input = new_inputs;
           end
        end
    end
    
    methods
        
        function obj = EMLGenerator(data)
            obj.data = data;
        end
        
        function [] = set_datatype(obj,type)
            obj.datatype = type;
        end
        
        function code = generate_preamble(obj)
                code = [];

                %generate input list
                parsed_input = EMLGenerator.parse_inputs(obj.data.function_inputs);
                input = [];
                for i= 1:size(parsed_input,2)
                    input = [input char(parsed_input{i}(1))];
                    if i ~= size(parsed_input,2)
                        input = [input ',']
                    end
                end
                code = sprintf('function output = %s(%s)\n%s\n',obj.data.function_name,input,'%%#eml');
                % simulink forces you to have an output for all execution paths
                % since it can't compute completness and disjointness we need
                % to have a default value, if the user builds the table
                % properly the default value will never be used. since
                % different types might have a different default value, the
                % temporary solution is just to use one of the outputs from our
                % table, we will use the first cell because it is
                % guaranteed to
                % be filled in, regardless of the dimensionality of the table.
                code = [code sprintf('output=%s(%s);\n',obj.datatype,char(obj.data.Grid0.Cells(1).result_text))];
        
        end
        
        
        function code = generate_eml_code(obj)
            code = [];
            code = [code obj.generate_preamble];
            code = [code obj.generate_eml_cond(obj.data.Grid1,obj.data.Grid2,0)];
            %code = [code obj.generate_conditional(obj.data.Grid1,obj.data.Grid2,0)];
            
        end
        
          
        
        %% generate_eml_horizontal
        function code = generate_eml_horizontal(obj,g1,g2_cell,depth)
            space = '';
            for i=1:depth
                space = [space sprintf('  ')];
            end
        code = [];

            elsecell = [];
            for i=1:size(g1.cells,2)
                g1cond = g1.cells(i).cond_text;
                % condition string of otherwise corresponds to an else
                % statement, we allow this statement to be in any order
                % in the cells of the grid, so we need to find where it
                % is, if it exists.
                if (strcmp(g1cond,'otherwise'))
                    elsecell = g1.cells(i);
                    found = 1;
                    continue
                end
                if (i == 1)
                    code = [code sprintf('%sif(%s)\n',space,strtrim(char(g1.cells(i).cond_text)))];
                else
                    code = [code sprintf('%selseif(%s)\n',space,strtrim(char(g1.cells(i).cond_text)))];
                end
                resultcell = obj.data.Grid0.search_return(g1.cells(i),g2_cell);
                if(~isempty(resultcell))
                     code = [code sprintf('%soutput = %s(%s);\n',[space '  '],obj.datatype,strtrim(char(resultcell.result_text)))];
                                      
                else
                end
            end
            if(~isempty(elsecell))
                 resultcell = obj.data.Grid0.search_return(elsecell,g2_cell);
                code = [code sprintf('%selse\n%soutput = %s(%s);\n',space,[space '  '],obj.datatype,strtrim(char(resultcell.result_text)))];

            end
            code = [code sprintf('%send\n',space)];

        end
        
        %% genereate_pvs
        function code = generate_eml_cond(obj,g1,g2,depth)
             space = '';
            for i=1:depth
                space = [space sprintf('  ')];
            end
          g1cond1 = g1.cells(1).cond_text;
          g2cond1 = g2.cells(1).cond_text;
          code = [];
          %1D horizontal
          if(~isempty(g1cond1) && isempty(g2cond1))
            code = [code obj.generate_eml_horizontal(g1,g2.cells(1),depth)];
          % something in vertical column
          else

            elsecell = [];
            for i=1:size(g2.cells,2)
                g2cond = g2.cells(i).cond_text;
                % condition string of otherwise corresponds to an else
                % statement, we allow this statement to be in any order
                % in the cells of the grid, so we need to find where it
                % is, if it exists.
                if (strcmp(g2cond,'otherwise'))
                    elsecell = g2.cells(i);
                    found = 1;
                    continue
                end
                if (i == 1)
                    code = [code sprintf('%sif(%s)\n',space,(strtrim(char(g2.cells(i).cond_text))))];
                else
                    code = [code sprintf('%selseif(%s)\n',space,(strtrim(char(g2.cells(i).cond_text))))];
                end

                if(~isempty(g2.cells(i).subgrid))
                    code = [code obj.generate_eml_cond(g1,g2.cells(i).subgrid,depth+1)];
                else
                    if (~isempty(g1cond1))
                         code = [code obj.generate_eml_horizontal(g1,g2.cells(i),depth+1)];
                    else    
                
                        resultcell = obj.data.Grid0.search_return(g1.cells(1),g2.cells(i));
                        if(~isempty(resultcell))
                                code = [code sprintf('%soutput = %s(%s);\n',[space '  '],obj.datatype,strtrim(char(resultcell.result_text)))];

                        else
                        end
                    end
                end
              
            end
           if(~isempty(elsecell))
                 %resultcell = obj.Grid0.search_return(elsecell,elsecell);
                code = [code sprintf('%selse\n',space)];

                if(~isempty(elsecell.subgrid))
                    code = [code obj.generate_eml_cond(g1,elsecell.subgrid,depth) sprintf('\n')];
                else
                    if (~isempty(g1cond1))
                         code = [code obj.generate_eml_horizontal(g1,elsecell,depth) sprintf('\n')];
                    else    
                
                        resultcell = obj.data.Grid0.search_return(g1.cells(1),elsecell);
                        if(~isempty(resultcell))
                             code = [code sprintf('%soutput = %s(%s);\n',[space '  '],obj.datatype,strtrim(char(resultcell.result_text)))];
                                
                        end
                    end
                end
                
           end

         code = [code sprintf('%send\n',space)];

          end
        end
        
    end
    
end

